function BarProfilerCreateProfile(ProfileName, CreatePosition)
	local key
	local value
	if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[ProfileName] ~= nil then
		BarProfiler:Print ("Error - That Profile name is already being used")
		BarProfilerGuiMainCloseHandler()
		BarProfiler:BarProfilerSlash(nil)
		return 1
	end
	if CreatePosition == nil then
		table.insert (BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList, ProfileName)
		BarProfiler:Print("Profile", ProfileName, "created successfully")
	else
		table.insert (BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList, CreatePosition, ProfileName)
	end
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[ProfileName] = {}
	for CreateSlotsLoop = 1, 120 do
		BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[ProfileName][CreateSlotsLoop] = {}
	end
	BarProfilerGuiMainCloseHandler()
	BarProfiler:BarProfilerSlash(nil)
end
function BarProfilerDeleteProfile(PrintCheck)
	local DeleteName = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList[BarProfilerDb.SelectedProfile]
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[DeleteName] = nil	
	table.remove(BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList, BarProfilerDb.SelectedProfile)
	if PrintCheck == nil then
		BarProfiler:Print ("Profile", DeleteName, "deleted successfully")
	end
	BarProfilerGuiMainCloseHandler()
	BarProfiler:BarProfilerSlash(nil)
end
function BarProfilerRenameProfile(NewProfileName)
	local CreatePosition = BarProfilerDb.SelectedProfile + 1
	local error = BarProfilerCreateProfile (NewProfileName, CreatePosition)
	if error == 1 then
		BarProfilerGuiMainCloseHandler()
		BarProfiler:BarProfilerSlash(nil)
		return
	end
	local OldProfileName = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList[BarProfilerDb.SelectedProfile]
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[NewProfileName] = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[OldProfileName]
	BarProfilerDeleteProfile(1)
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[NewProfileName].DataCheck = 1
	BarProfiler:Print ("Profile", OldProfileName, "renamed to", NewProfileName)
end