BarProfiler = LibStub("AceAddon-3.0"):NewAddon("BarProfiler", "AceConsole-3.0")
BarProfilerIcon = LibStub("LibDBIcon-1.0")
BarProfilerGui = LibStub("AceGUI-3.0")
BarProfiler:RegisterChatCommand("barprofiler", "BarProfilerSlash")
function BarProfiler:OnInitialize()
	BarProfilerDebug = 0	--needs moving into Db
	local Slot = 1
	if BarProfilerDb == nil then
		BarProfilerDb = {
			Version = 0.1,
			Realms = {},
			RealmList = {},
		}
		BarProfiler:Print ("Creating and initialising database to 0.1")
	end
	if BarProfilerDb.Version == 0.1 then
		BarProfilerDb.Version = 0.2
		BarProfilerDb.Minimap = {
			minimapPos = 243.5,
			Hide = false,
			Info = {}
		}
		BarProfiler:Print ("Upgrading database to 0.2")
	end
	if BarProfilerDb.Version == 0.2 then
		BarProfilerDb.Version = "0.2.1"
		BarProfilerDb.GUI = {
			Main = {
				point = "CENTER",
				relativeTo = nil,
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0
			},
			ConfirmationWindow = {
				point = "CENTER",
				relativeTo = nil,
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0
			}
		}
		BarProfiler:Print ("Upgrading database to 0.2.1")
	end
	BarProfilerDb.CurrentRealm = GetRealmName()
	BarProfilerDb.CurrentCharacter = GetUnitName("player", True)
	if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm] == nil then
		BarProfilerNewRealm()
		BarProfilerNewCharacter()
	else
		if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter] == nil then
			BarProfilerNewCharacter()
		end
	end
	BarProfilerSlashCount = 0	--needs moving into Db
	tinsert(UISpecialFrames,"BarProfilerMainFrame")
	tinsert(UISpecialFrames,"BarProfilerMessageFrame")
	BarProfilerDb.Minimap.Info = LibStub("LibDataBroker-1.1"):NewDataObject("BarProfilerIconLabel", {
		type = "data source",
		text = "BarProfilerIconLabel",
		icon = "Interface\\Icons\\Achievement_guildperk_workingovertime",
		OnClick = function() BarProfiler:BarProfilerSlash(nil) end,
		OnTooltipShow = function(tooltip)
		tooltip:AddLine("Bar Profiler")
		end,
	})
	BarProfilerIcon:Register("BarProfilerIconLabel", BarProfilerDb.Minimap.Info, BarProfilerDb.Minimap)
	BarProfiler:Print ("Loaded")
end
local BarProfilerFrame = CreateFrame("Frame")
	BarProfilerFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	local function eventHandler()
		BarProfilerMinimapToggleHandler (BarProfilerDb.Minimap.Hide)
	end
BarProfilerFrame:SetScript("OnEvent", eventHandler);
function BarProfilerNewRealm()
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm] = 	{
		CharacterList = {},
		Characters = {}
	}
	table.insert (BarProfilerDb.RealmList, BarProfilerDb.CurrentRealm)
end
function BarProfilerNewCharacter()
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter] = 	{
		ProfileList = {},
		Profiles = {}
	}
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Class = UnitClass("player")
	table.insert (BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].CharacterList, BarProfilerDb.CurrentCharacter)
end
function BarProfiler:BarProfilerSlash(input)
	if input == "resetgui" then
		BarProfilerDb.GUI = {
			Main = {
				point = "CENTER",
				relativeTo = nil,
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0
			},
			ConfirmationWindow = {
				point = "CENTER",
				relativeTo = nil,
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0
			}
		}
		BarProfiler:Print ("Position of GUI reset to center")
		return
	end
	if BarProfilerSlashCount == 0 then
		BarProfilerSlashCount = 1
		BarProfilerGuiMain()
	else
		BarProfilerSlashCount = 0
		BarProfilerGuiMainCloseHandler()
	end
end
function BarProfilerDebugPrint(Str)
	if BarProfilerDebug == 1 then
		BarProfiler:Print ("DEBUG:",Str)
	end
end